import operator
import datetime
import dateutil.parser
import time
import csv
import math
from collections import defaultdict

def getNumInputsMedian(data):
    if len(data) == 0:
        return
    dataSorted = sorted(data.iteritems(), key=operator.itemgetter(1))
    median = -1
    if len(dataSorted) % 2 == 1:
        median = dataSorted[len(dataSorted) / 2][1]
        print dataSorted[len(dataSorted) / 2]
    else:
        median = (dataSorted[len(dataSorted) / 2 - 1][1] + dataSorted[len(dataSorted) / 2][1]) / 2.0
        print dataSorted[len(dataSorted) / 2 - 1]
        print dataSorted[len(dataSorted) / 2 + 1]
    return


def getBasicParticipatingStats(data, projId, paramId, paramType):
    if len(data) == 0:
        return

    inputDict = {};
    res = data["results"]
    for jo in res:
        if 'projId' in jo:
            if jo['projId'] != projId: #look for specfic event
                continue
        else:
            continue

        if jo['paramId'] != paramId: #look for specfic param
            continue

        curUid = jo["userId"]
        if curUid.startswith("simulator"): #skip simulators
            continue

        if curUid in inputDict:
            inputDict[curUid] = inputDict[curUid] + 1
        else:
            inputDict.update({curUid : 1})

    #general user activity stats
    print "\ninputs count: "
    print sum(inputDict.itervalues())

    print "\nnumber of users: "
    print len(inputDict)

    print "\nnumber of inputs per user: "
    for i in inputDict:
        print i + ': ' +  str(inputDict[i])

    print "\naverage number of user input: "
    print sum(inputDict.itervalues()) / float(len(inputDict))

    print "\nmedian of inputs: "
    getNumInputsMedian(inputDict)
    print "\n\n"
    return

def getBasicParticipatingStatsInRange(data, projId, paramId, paramType, startTime, endTime, isTimeInNumber):
    if len(data) == 0:
        return

    if isinstance(startTime, basestring):
        epoch = datetime.datetime.utcfromtimestamp(0)
        startTime = datetime.datetime.strptime(startTime, "%Y-%m-%dT%H:%M:%S.%fZ")
        delta = startTime - epoch
        startTime = int(delta.total_seconds() * 1000.0)

        endTime = datetime.datetime.strptime(endTime, "%Y-%m-%dT%H:%M:%S.%fZ")
        delta = endTime - epoch
        endTime = int(delta.total_seconds() * 1000.0)

    inputDict = {};
    res = data["results"]
    for jo in res:

        curInputTime = jo["updatedAt"]
        if isTimeInNumber == False:
            curInputTime = datetime.datetime.strptime(curInputTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            epoch = datetime.datetime.utcfromtimestamp(0)
            delta = curInputTime - epoch
            curInputTime = int(delta.total_seconds() * 1000.0)

        if (curInputTime < startTime) or (curInputTime > endTime):
            continue 

        if jo['projId'] != projId: #look for specfic event
            continue

        if jo['paramId'] != paramId: #look for specfic param
            continue

        curUid = jo["userId"]
        if curUid.startswith("simulator"): #skip simulators
            continue

        if curUid in inputDict:
            inputDict[curUid] = inputDict[curUid] + 1
        else:
            inputDict.update({curUid : 1})

    #general user activity stats
    print 'time length: ' + str((endTime - startTime) / 1000.0) + ' seconds'

    print "\ninputs count: "
    print sum(inputDict.itervalues())

    print "\nnumber of users: "
    print len(inputDict)

    print "\nnumber of inputs per user: "
    for i in inputDict:
        print i + ': ' +  str(inputDict[i])

    print "\naverage number of user input: "
    if (len(inputDict) == 0):
        print '0'
    else:
        print sum(inputDict.itervalues()) / float(len(inputDict))

    print "\nmedian of inputs: "
    getNumInputsMedian(inputDict)
    print "\n\n"
    return

#export csv; manual time needs iso millisecond int
def paramValuesMedianAlongTime(projId, paramId, paramType, data, manualStartTime, manualEndTime, useManualTime, timeDelta, isTimeInNumber):
    res = data["results"]
    #find earliest time
    startTime = -1
    endTime = -1
    if useManualTime == False:
        startTime = getEarliestTimeInList(projId, paramId, res)
        endTime = getLatestTimeInList(projId, paramId, res)
        if startTime == -1:
            print "finding start data error"
            return
        if endTime == -1:
            print "finding end time data error"
            return
        if isTimeInNumber == False:
            epoch = datetime.datetime.utcfromtimestamp(0)
            startTime = datetime.datetime.strptime(startTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = startTime - epoch
            startTime = int(delta.total_seconds() * 1000.0)

            endTime = datetime.datetime.strptime(endTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = endTime - epoch
            endTime = int(delta.total_seconds() * 1000.0)
    else:
        startTime = manualStartTime
        endTime = manualEndTime
        print "manual"
        print startTime
        print endTime

    curTime = startTime
    timeIndex = 1
    median = []
    while 1:
        windowEndTime = -1
        if curTime + timeDelta > endTime:
            windowEndTime = endTime
        else:
            windowEndTime = curTime + timeDelta
        if windowEndTime == -1:
            print "window end time invalid, should not happen"
            return

        curData = paramValuesInWindow(projId, paramId, paramType, data, curTime, windowEndTime, isTimeInNumber)
        medianX = 0
        medianY = 0
        if len(curData) > 0:
            if paramType == 0:
                print "slider 1d"
            elif paramType == 1:
                # print "slider 2d"
                # print "startTime: " + str(startTime)
                # print "windowendtime: " + str(windowEndTime)
                # print "endtime: " + str(endTime)
                # print "curtime: " + str(curTime)
                # print timeIndex
                # print curData
                
                x = []
                y = []
                for key in curData:
                    paramData = curData[key]
                    x.append(paramData['x'])
                    y.append(paramData['y'])
                x.sort()
                y.sort()
                if len(x) % 2 == 1:
                    medianX = x[len(x) / 2]
                    medianY = y[len(y) / 2]
                else:
                    medianX = (x[len(x) / 2 - 1] + x[len(x) / 2]) / 2.0
                    medianY = (y[len(y) / 2 - 1] + y[len(y) / 2]) / 2.0

            elif paramType == 2:
                print "vote"
            elif paramType == 4:
                print "draw"
            elif paramType == 5:
                print "palette"
            else:
                print "parameter type unknown"

        median.append([timeIndex, medianX, medianY])
        timeIndex = timeIndex + 1
        curTime = curTime + timeDelta
        if curTime > endTime:
            break

    tableTitle = []
    if paramType == 0:
        print "slider 1d"
    elif paramType == 1:
        tableTitle = ['time', 'medianX', 'medianY']
    elif paramType == 2:
        print "vote"
    elif paramType == 4:
        print "draw"
    elif paramType == 5:
        print "palette"
    else:
        print "parameter type unknown"

    cot = csv.writer(open('/Users/shaoduo/Desktop/medianCurve.csv','wb'))
    cot.writerow(tableTitle)
    for t in median:
        cot.writerow(t)


#export csv; manual time needs iso millisecond int
def paramValuesAverageAlongTime(projId, paramId, paramType, data, manualStartTime, manualEndTime, useManualTime, timeDelta, isTimeInNumber):
    res = data["results"]
    #find earliest time
    startTime = -1
    endTime = -1
    if useManualTime == False:
        startTime = getEarliestTimeInList(projId, paramId, res)
        endTime = getLatestTimeInList(projId, paramId, res)
        if startTime == -1:
            print "finding start data error"
            return
        if endTime == -1:
            print "finding end time data error"
            return
        if isTimeInNumber == False:
            epoch = datetime.datetime.utcfromtimestamp(0)
            startTime = datetime.datetime.strptime(startTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = startTime - epoch
            startTime = int(delta.total_seconds() * 1000.0)

            endTime = datetime.datetime.strptime(endTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = endTime - epoch
            endTime = int(delta.total_seconds() * 1000.0)
    else:
        startTime = manualStartTime
        endTime = manualEndTime
        print "manual"
        print startTime
        print endTime

    curTime = startTime
    timeIndex = 1
    avg = []
    while 1:
        windowEndTime = -1
        if curTime + timeDelta > endTime:
            windowEndTime = endTime
        else:
            windowEndTime = curTime + timeDelta
        if windowEndTime == -1:
            print "window end time invalid, should not happen"
            return

        curData = paramValuesInWindow(projId, paramId, paramType, data, curTime, windowEndTime, isTimeInNumber)
        avgX = 0
        avgY = 0
        if len(curData) > 0:
            if paramType == 0:
                print "slider 1d"
            elif paramType == 1:  
                sumX = 0
                sumY = 0
                for key in curData:
                    paramData = curData[key]
                    sumX = sumX + paramData['x']
                    sumY = sumY + paramData['y']

                avgX = sumX / float(len(curData))
                avgY = sumY / float(len(curData))

            elif paramType == 2:
                print "vote"
            elif paramType == 4:
                print "draw"
            elif paramType == 5:
                print "palette"
            else:
                print "parameter type unknown"

        avg.append([timeIndex, avgX, avgY])
        timeIndex = timeIndex + 1
        curTime = curTime + timeDelta
        if curTime > endTime:
            break

    tableTitle = []
    if paramType == 0:
        print "slider 1d"
    elif paramType == 1:
        tableTitle = ['time', 'avgX', 'avgY']
    elif paramType == 2:
        print "vote"
    elif paramType == 4:
        print "draw"
    elif paramType == 5:
        print "palette"
    else:
        print "parameter type unknown"

    cot = csv.writer(open('/Users/shaoduo/Desktop/averageCurve.csv','wb'))
    cot.writerow(tableTitle)
    for t in avg:
        cot.writerow(t)


#export csv; manual time needs iso millisecond int
def paramValuesStandardDeviationAlongTime(projId, paramId, paramType, data, manualStartTime, manualEndTime, useManualTime, timeDelta, isTimeInNumber):
    res = data["results"]
    #find earliest time
    startTime = -1
    endTime = -1
    if useManualTime == False:
        startTime = getEarliestTimeInList(projId, paramId, res)
        endTime = getLatestTimeInList(projId, paramId, res)
        if startTime == -1:
            print "finding start data error"
            return
        if endTime == -1:
            print "finding end time data error"
            return
        if isTimeInNumber == False:
            epoch = datetime.datetime.utcfromtimestamp(0)
            startTime = datetime.datetime.strptime(startTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = startTime - epoch
            startTime = int(delta.total_seconds() * 1000.0)

            endTime = datetime.datetime.strptime(endTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = endTime - epoch
            endTime = int(delta.total_seconds() * 1000.0)
    else:
        startTime = manualStartTime
        endTime = manualEndTime
        print "manual"
        print startTime
        print endTime

    curTime = startTime
    timeIndex = 1
    sd = []
    while 1:
        windowEndTime = -1
        if curTime + timeDelta > endTime:
            windowEndTime = endTime
        else:
            windowEndTime = curTime + timeDelta
        if windowEndTime == -1:
            print "window end time invalid, should not happen"
            return

        curData = paramValuesInWindow(projId, paramId, paramType, data, curTime, windowEndTime, isTimeInNumber)

        sdX = 0
        sdY = 0
        if len(curData) > 0:
            if paramType == 0:
                print "slider 1d"
            elif paramType == 1:
                x = []
                y = []
                
                for key in curData:
                    paramData = curData[key]
                    x.append(paramData['x'])
                    y.append(paramData['y'])

                avgX = float(sum(x, 0.0)) / len(x)
                avgY = float(sum(y, 0.0)) / len(y)
                sumX = 0.0;
                for xi in x:
                    sumX = sumX + pow((xi - avgX), 2)
                sdX = math.sqrt(sumX / len(x))
                sumY = 0.0;
                for yi in y:
                    sumY = sumY + pow((yi - avgY), 2)
                sdY = math.sqrt(sumY / len(y))

            elif paramType == 2:
                print "vote"
            elif paramType == 4:
                print "draw"
            elif paramType == 5:
                print "palette"
            else:
                print "parameter type unknown"

        sd.append([timeIndex, sdX, sdY])
        timeIndex = timeIndex + 1
        curTime = curTime + timeDelta
        if curTime > endTime:
            break

    tableTitle = []
    if paramType == 0:
        print "slider 1d"
    elif paramType == 1:
        tableTitle = ['time', 'SDX', 'SDY']
    elif paramType == 2:
        print "vote"
    elif paramType == 4:
        print "draw"
    elif paramType == 5:
        print "palette"
    else:
        print "parameter type unknown"

    cot = csv.writer(open('/Users/shaoduo/Desktop/standardDeviationCurve.csv','wb'))
    cot.writerow(tableTitle)
    for t in sd:
        cot.writerow(t)


#export csv; manual time needs iso millisecond int
def userActivityAlongTime(projId, paramId, paramType, data, manualStartTime, manualEndTime, useManualTime, timeDelta, isTimeInNumber):
    res = data["results"]
    #find earliest time
    startTime = -1
    endTime = -1
    if useManualTime == False:
        startTime = getEarliestTimeInList(projId, paramId, res)
        endTime = getLatestTimeInList(projId, paramId, res)
        if startTime == -1:
            print "finding start data error"
            return
        if endTime == -1:
            print "finding end time data error"
            return
        if isTimeInNumber == False:
            epoch = datetime.datetime.utcfromtimestamp(0)
            startTime = datetime.datetime.strptime(startTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = startTime - epoch
            startTime = int(delta.total_seconds() * 1000.0)

            endTime = datetime.datetime.strptime(endTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = endTime - epoch
            endTime = int(delta.total_seconds() * 1000.0)
    else:
        startTime = manualStartTime
        endTime = manualEndTime
        print "manual"
        print startTime
        print endTime

    getUsefulData(projId, paramId, paramType, data, startTime, endTime, False)

    curTime = startTime
    timeIndex = 1
    numOfInputs = []
    while 1:
        windowEndTime = -1
        if curTime + timeDelta > endTime:
            windowEndTime = endTime
        else:
            windowEndTime = curTime + timeDelta
        if windowEndTime == -1:
            print "window end time invalid, should not happen"
            return

        print (float)(curTime - startTime) / (endTime - startTime)
        curDataUniqueUser = paramValuesInWindow(projId, paramId, paramType, data, curTime, windowEndTime, isTimeInNumber)
        curDataAll = paramValuesInWindowGetAll(projId, paramId, paramType, data, curTime, windowEndTime, isTimeInNumber)

        #print curDataAll

        sumInputs = 0
        for eachUser in curDataAll:
            sumInputs = sumInputs + len(curDataAll[eachUser])

        numOfInputs.append([timeIndex, len(curDataUniqueUser), sumInputs])
        timeIndex = timeIndex + 1
        curTime = curTime + timeDelta
        if curTime > endTime:
            break

    tableTitle = ['timeIndex', 'numOfInputsFromUniqueUser', 'numOfInputs']

    cot = csv.writer(open('/Users/shaoduo/Desktop/userInputsActivity.csv','wb'))
    cot.writerow(tableTitle)
    for t in numOfInputs:
        cot.writerow(t)


#export csv; manual time needs iso millisecond int
def userInputsAlongTime(projId, paramId, paramType, data, manualStartTime, manualEndTime, useManualTime, timeDelta, isTimeInNumber, userId):
    res = data["results"]
    #find earliest time
    startTime = -1
    endTime = -1
    if useManualTime == False:
        startTime = getEarliestTimeInList(projId, paramId, res)
        endTime = getLatestTimeInList(projId, paramId, res)
        if startTime == -1:
            print "finding start data error"
            return
        if endTime == -1:
            print "finding end time data error"
            return
        if isTimeInNumber == False:
            epoch = datetime.datetime.utcfromtimestamp(0)
            startTime = datetime.datetime.strptime(startTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = startTime - epoch
            startTime = int(delta.total_seconds() * 1000.0)

            endTime = datetime.datetime.strptime(endTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            delta = endTime - epoch
            endTime = int(delta.total_seconds() * 1000.0)
            # startTime = dateutil.parser.parse(startTime)
            # endTime = dateutil.parser.parse(endTime)
            # #datetime to epoch milliseconds
            # startTime = int(time.mktime(startTime.timetuple()) * 1000 + startTime.microsecond / 1000)
            # endTime = int(time.mktime(endTime.timetuple()) * 1000 + endTime.microsecond / 1000)
    else:
        startTime = manualStartTime
        endTime = manualEndTime
        print "manual"
        print startTime
        print endTime



    curTime = startTime
    timeIndex = 1
    inputs = []
    while 1:
        windowEndTime = -1
        if curTime + timeDelta > endTime:
            windowEndTime = endTime
        else:
            windowEndTime = curTime + timeDelta
        if windowEndTime == -1:
            print "window end time invalid, should not happen"
            return

        curDataAll = paramValuesInWindowGetAll(projId, paramId, paramType, data, curTime, windowEndTime, isTimeInNumber)
        curX = 0
        curY = 0
        if len(curDataAll) > 0:
            if paramType == 0:
                print "slider 1d"
            elif paramType == 1:               
                for eachUser in curDataAll:
                    if eachUser == userId:
                        curX = curDataAll[eachUser][-1]['x'] #use the latest user input in this window
                        curY = curDataAll[eachUser][-1]['y']
            elif paramType == 2:
                print "vote"
            elif paramType == 4:
                print "draw"
            elif paramType == 5:
                print "palette"
            else:
                print "parameter type unknown"

        inputs.append([timeIndex, curX, curY])
        timeIndex = timeIndex + 1
        curTime = curTime + timeDelta
        if curTime > endTime:
            break

    tableTitle = []
    if paramType == 0:
        print "slider 1d"
    elif paramType == 1:
        tableTitle = ['time', 'x', 'y']
    elif paramType == 2:
        print "vote"
    elif paramType == 4:
        print "draw"
    elif paramType == 5:
        print "palette"
    else:
        print "parameter type unknown"

    cot = csv.writer(open('/Users/shaoduo/Desktop/userInputs-' + userId + '.csv','wb'))
    cot.writerow(tableTitle)
    for t in inputs:
        cot.writerow(t)


#stats on the parameter; output csv data; only get the latest data of every user
def paramValuesInWindow(projId, paramId, paramType, data, startTimeInt, endTimeInt, isTimeInNumber):
    inputDict = {}
    if len(data) == 0:
        print "input data is 0"
        return inputDict

    # startTimeInt = -1
    # endTimeInt = -1
    # if isTimeInNumber == False:
    #     #ISO String to datetime
    #     startTime = dateutil.parser.parse(startTime)
    #     endTime = dateutil.parser.parse(endTime)
    #     #datetime to epoch milliseconds
    #     startTimeInt = int(time.mktime(startTime.timetuple()) * 1000 + startTime.microsecond / 1000)
    #     endTimeInt = int(time.mktime(endTime.timetuple()) * 1000 + endTime.microsecond / 1000)
    # else:
    #     startTimeInt = startTime
    #     endTimeInt = endTime

    res = data["results"]
    for jo in res:
        if jo['projId'] != projId or jo['paramId'] != paramId or jo['paramType'] != paramType: #look for specfic event
            #print "row skipped"
            continue

        curUid = jo["userId"]
        if curUid.startswith("simulator"): #skip simulators
            continue

        curInputTime = jo["updatedAt"]
        if isTimeInNumber == False:
            curInputTime = datetime.datetime.strptime(curInputTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            epoch = datetime.datetime.utcfromtimestamp(0)
            delta = curInputTime - epoch
            curInputTimeInt = int(delta.total_seconds() * 1000.0)
        else:
            curInputTimeInt = curInputTime

        if curInputTimeInt >= startTimeInt and curInputTimeInt < endTimeInt:
            if curUid in inputDict:
                inputDict[curUid] = jo["keyValues"]
            else:
                inputDict.update({curUid : jo["keyValues"]})

        #json list is in order of time
        if curInputTimeInt > endTimeInt:
            break

    #print inputDict
    return inputDict


#stats on the parameter; output csv data; get all data of every user, not just the latest input of each user
def paramValuesInWindowGetAll(projId, paramId, paramType, data, startTimeInt, endTimeInt, isTimeInNumber):
    inputDict = defaultdict(list)
    if len(data) == 0:
        return inputDict

    res = data["results"]
    for jo in res:
        if jo['projId'] != projId or jo['paramId'] != paramId or jo['paramType'] != paramType: #look for specfic event
            continue

        curUid = jo["userId"]
        if curUid.startswith("simulator"): #skip simulators
            continue

        curInputTime = jo["updatedAt"]
        if isTimeInNumber == False:
            curInputTime = datetime.datetime.strptime(curInputTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            epoch = datetime.datetime.utcfromtimestamp(0)
            delta = curInputTime - epoch
            curInputTimeInt = int(delta.total_seconds() * 1000.0)
        else:
            curInputTimeInt = curInputTime

        if curInputTimeInt >= startTimeInt and curInputTimeInt < endTimeInt:
            inputDict[curUid].append(jo["keyValues"])

        #json list is in order of time
        if curInputTimeInt > endTimeInt:
            break

    #print inputDict
    return inputDict


def getEarliestTimeInList(projId, paramId, res):
    startTime = -1
    for jo in res:
        if jo['projId'] != projId or jo['paramId'] != paramId: #look for specfic event
            continue

        curUid = jo["userId"]
        if curUid.startswith("simulator"): #skip simulators
            continue

        startTime = jo["updatedAt"]
        return startTime

def getLatestTimeInList(projId, paramId, res):
    endTime = -1
    #find final time
    totalNum = len(res)
    for i in range(totalNum):
        index = totalNum - i - 1
        if res[index]['projId'] != projId or res[index]['paramId'] != paramId: #look for specfic event
            continue

        curUid = res[index]["userId"]
        if curUid.startswith("simulator"): #skip simulators
            continue
        endTime = res[index]["updatedAt"]
        return endTime


def getUsefulData(projId, paramId, paramType, data, startTimeInt, endTimeInt, isTimeInNumber):
    res = data["results"]
    for jo in res:
        if 'projId' not in jo:
            continue
        
        if jo['projId'] != projId or jo['paramId'] != paramId or jo['paramType'] != paramType: #look for specfic event
            #print "row skipped"
            continue

        curUid = jo["userId"]
        if curUid.startswith("simulator"): #skip simulators
            continue

        curInputTime = jo["updatedAt"]
        if isTimeInNumber == False:
            curInputTime = datetime.datetime.strptime(curInputTime, "%Y-%m-%dT%H:%M:%S.%fZ")
            epoch = datetime.datetime.utcfromtimestamp(0)
            delta = curInputTime - epoch
            curInputTimeInt = int(delta.total_seconds() * 1000.0)
        else:
            curInputTimeInt = curInputTime

        if curInputTimeInt >= startTimeInt and curInputTimeInt < endTimeInt:
            dummy = 0
        else:
            res.remove(jo)
